## org.bouncycastle.crypto
Interface Mac

All Known Implementing Classes:
  HMac

public interface Mac

The base interface for implementations of message authentication codes (MACs). modified by jrandom to use the session key byte array directly

Method Summary
`int` `doFinal(byte[] out, int outOff)` Compute the final statge of the MAC writing the output to the out parameter.
`java.lang.String` `getAlgorithmName()` Return the name of the algorithm the MAC implements.
`int` `getMacSize()` Return the block size for this cipher (in bytes).
`void` `init(byte[] key)` Initialise the MAC.
`void` `reset()` Reset the MAC.
`void` `update(byte in)` add a single byte to the mac for processing.
`void` `update(byte[] in, int inOff, int len)`

Method Detail

### init

    public void init(byte[] key)
              throws java.lang.IllegalArgumentException

  Initialise the MAC.

  Parameters:
    `key` - the key required by the MAC.
  Throws:
    `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

### getAlgorithmName

    public java.lang.String getAlgorithmName()

  Return the name of the algorithm the MAC implements.

  Returns:
    the name of the algorithm the MAC implements.

### getMacSize

    public int getMacSize()

  Return the block size for this cipher (in bytes).

  Returns:
    the block size for this cipher in bytes.

### update

    public void update(byte in)
                throws java.lang.IllegalStateException

  add a single byte to the mac for processing.

  Parameters:
    `in` - the byte to be processed.
  Throws:
    `java.lang.IllegalStateException` - if the MAC is not initialised.

### update

    public void update(byte[] in,
                       int inOff,
                       int len)
                throws java.lang.IllegalStateException

  Parameters:
    `in` - the array containing the input.
    `inOff` - the index in the array the data begins at.
    `len` - the length of the input starting at inOff.
  Throws:
    `java.lang.IllegalStateException` - if the MAC is not initialised.

### doFinal

    public int doFinal(byte[] out,
                       int outOff)
                throws java.lang.IllegalStateException

  Compute the final statge of the MAC writing the output to the out parameter.

  doFinal leaves the MAC in the same state it was after the last init.

  Parameters:
    `out` - the array the MAC is to be output to.
    `outOff` - the offset into the out buffer the output is to start at.
  Throws:
    `java.lang.IllegalStateException` - if the MAC is not initialised.

### reset

    public void reset()

  Reset the MAC. At the end of resetting the MAC should be in the in the same state it was after the last init (if there was one).